#pragma semicolon 1
#include <sourcemod>
#include <sdktools>
#include <vip_core>
#include <clientprefs>

public Plugin:myinfo = 
{
	name = "[VIP] Grenades (CS:S)",
	author = "R1KO",
	version = "1.0.0"
};

#define VIP_GRENADES		"Grenades"

new m_iAmmo;

new const String:g_sGrens[][] =
{
	"weapon_hegrenade",
	"weapon_flashbang",
	"weapon_smokegrenade"
};

public OnPluginStart() 
{
	m_iAmmo = FindSendPropInfo("CBasePlayer", "m_iAmmo");
}

public VIP_OnVIPLoaded()
{
	VIP_RegisterFeature(VIP_GRENADES, STRING, _, OnToggleItem);
	
	VIP_HookClientSpawn(OnPlayerSpawn);
}

public VIP_OnVIPClientLoaded(iClient)
{
	if(VIP_IsClientFeatureUse(iClient, VIP_GRENADES))
	{
		GetClientGrens(iClient);
	}
}

GetClientGrens(iClient)
{
	decl String:sBuffer[64], String:sParts[3][3], iParts;
	VIP_GetClientFeatureString(iClient, VIP_GRENADES, sBuffer, sizeof(sBuffer));
	if((iParts = ExplodeString(sBuffer, ";", sParts, sizeof(sParts), sizeof(sParts[]))) < 4)
	{
		decl i;
		for(i = 0; i < iParts; ++i)
		{
			SetTrieValue(VIP_GetVIPClientTrie(iClient), g_sGrens[i], StringToInt(sParts[i]));
		}
	}
}

public Action:OnToggleItem(iClient, const String:sFeatureName[], VIP_ToggleState:OldStatus, &VIP_ToggleState:NewStatus)
{
	if(NewStatus == ENABLED)
	{
		GetClientGrens(iClient);
	}
	else
	{
		decl i, Handle:hTrie;
		hTrie = VIP_GetVIPClientTrie(iClient);
		for(i = 0; i < 3; ++i)
		{
			RemoveFromTrie(hTrie, g_sGrens[i]);
		}
	}
	return Plugin_Continue;
}

public OnPlayerSpawn(iClient, iTeam, bool:bIsVIP)
{
	if(bIsVIP && VIP_IsClientFeatureUse(iClient, VIP_GRENADES))
	{
		decl iCount, i, iOffs, Handle:hTrie;
		hTrie = VIP_GetVIPClientTrie(iClient);
		for(i = 0; i < 3; ++i)
		{
			if(GetTrieValue(hTrie, g_sGrens[i], iCount) && iCount > 0)
			{
				iOffs = m_iAmmo + ((i+11)*4);
				if (GetEntData(iClient, iOffs) < 1)
				{
					GivePlayerItem(iClient, g_sGrens[i]);
				}

				SetEntData(iClient, iOffs, iCount);
			}
		}
	}
}